<template>
	<v-container class="field-show flex-grow-1" :class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
		<div class="mb-5 container">
			<v-skeleton-loader v-if="groupsAreLoading" type="card" min-height="500px" />
			<div v-else-if="groupsHaveError" rounded="lg">Error loading group. Please refresh.</div>
			<div v-else-if="groupsAreLoaded && group">
				<breadcrumbs :group="group" :groups="groups" />
				<h2 class="d-flex">{{ group.name }}</h2>
			</div>
		</div>

		<div class="mb-5">
			<v-container class="d-flex justify-space-between align-center">
				<h3>Subgroups</h3>
				<v-btn class="primary my-auto d-inline-block" rounded @click="addGroup">Add subgroup</v-btn>
			</v-container>
			<v-card class="pb-2" rounded="lg">
				<v-card-text>
					<group-list-row v-for="group in childGroups" :key="group.id" :group="group" />
					<div v-if="childGroups.length === 0">This group does not have any subgroups.</div>
				</v-card-text>
			</v-card>
		</div>

		<div class="mb-5">
			<v-container class="d-flex justify-space-between align-center">
				<h3>Members</h3>
				<v-btn class="px-4" color="primary" @click="addMember" depressed rounded>Add Member</v-btn>
			</v-container>
			<v-card>
				<v-card-text>
					<v-data-table
						:headers="[
							{ text: 'Email', value: 'email' },
							{ text: '', value: 'actions', width: '10%' },
						]"
						:footer-props="{
							'items-per-page-options': [10],
						}"
						:mobile-breakpoint="-1"
						:disable-pagination="memberships.length <= 10"
						:hide-default-footer="memberships.length <= 10"
						:loading="membershipsAreLoading || userIsLoading"
						:items="memberships.map((membership) => ({ email: membership.user.email, membership }))"
						:no-data-text="
							membershipsHaveError ? 'There was an error loading memberships. Please refresh.' : 'No memberships found.'
						"
					>
						<template v-slot:item.actions="{ item }">
							<membership-delete-button
								:membership="item.membership"
								v-if="!userHasError && item.email !== (user && user.email)"
							/>
						</template>
					</v-data-table>
				</v-card-text>
			</v-card>
		</div>
	</v-container>
</template>

<script lang="ts">
import { computed, defineComponent, SetupContext } from '@vue/composition-api';
import { find } from 'lodash';
import { useGroups } from '@/store/modules/group';
import { getGroupTree } from '@/store/modules/group/utils';
import { useMemberships } from '@/store/modules/memberships';
import { useUser } from '@/store/modules/user';
import { Group } from '@/store/types';
import Breadcrumbs from '@/views/group/Breadcrumbs.vue';
import GroupListRow from '@/views/group/GroupListRow.vue';
import MembershipDeleteButton from '@/views/group/MembershipDeleteButton.vue';

export default defineComponent({
	components: { MembershipDeleteButton, Breadcrumbs, GroupListRow },
	props: {
		id: { type: String, required: true },
	},
	setup(props, { root }: SetupContext) {
		const {
			isLoading: membershipsAreLoading,
			isLoaded: membershipsAreLoaded,
			hasError: membershipsHaveError,
			memberships,
		} = useMemberships(root.$store, props.id);
		const {
			isLoading: groupsAreLoading,
			isLoaded: groupsAreLoaded,
			hasError: groupsHaveError,
			groups,
			groupTree,
		} = useGroups(root.$store);
		const { isLoading: userIsLoading, hasError: userHasError, user } = useUser(root.$store);
		const group = computed<Group | undefined>(() => groups.value.find((g) => g.id === props.id));
		const childGroups = computed<Group[]>(() => getGroupTree(groups.value, undefined, group.value));

		const addMember = () => {
			root.$router.push(`/groups/${group.value?.id}/membership/new/`);
		};

		const addGroup = () => {
			root.$router.push(`/groups/${group.value?.id}/new`);
		};

		return {
			groups,
			group,
			groupTree,
			find,
			memberships,
			groupsAreLoading,
			groupsAreLoaded,
			groupsHaveError,
			membershipsAreLoading,
			membershipsAreLoaded,
			membershipsHaveError,
			childGroups,
			addMember,
			addGroup,
			user,
			userIsLoading,
			userHasError,
		};
	},
});
</script>

<style scoped>
>>> .v-list-item + .v-list-item {
	border-top: 1px solid #ccc;
}
</style>
